#include "mementotree.h"


const int MEMENTOTREE_OFFSET_TREESIZE = 0;
const int MEMENTOTREE_OFFSET_SIZE = 4;
const int MEMENTOTREE_HEADER_SIZE = 8;




int CMementoTree::get_size(void *buffer)
{
	int sz=0;
	memcpy(&sz,&((char*)buffer)[MEMENTOTREE_OFFSET_SIZE],sizeof(sz));
	return sz;
}

int CMementoTree::get_treesize(void *buffer)
{
	int sz=0;
	memcpy(&sz,&((char*)buffer)[MEMENTOTREE_OFFSET_TREESIZE],sizeof(sz));
	return sz;
}
int CMementoTree::set_size(void *buffer,int size)
{
	memcpy(&((char*)buffer)[MEMENTOTREE_OFFSET_SIZE],&size,sizeof(size));
	return 0;

}
int CMementoTree::set_treesize(void *buffer,int size)
{
	memcpy(&((char*)buffer)[MEMENTOTREE_OFFSET_TREESIZE],&size,sizeof(size));
	return 0;
}

void CMementoTree::deleteobj()
{
	CMEMENTOTREE_V::iterator i;
	for(i=mements.begin();i!=mements.end();i++)
	{delete (*i);}
	mements.clear();

	delete [] buff;
	buff = NULL;
}

CMementoTree::CMementoTree()
{
	buff = NULL;
}
CMementoTree::~CMementoTree()
{
	deleteobj();
}


int CMementoTree::create_buffer(int size)
{
	deleteobj();

	buff = new char[size+MEMENTOTREE_HEADER_SIZE];
	memset(buff,0,size+MEMENTOTREE_HEADER_SIZE);

	set_size(buff,size);

	return 0;
}

int CMementoTree::get_size()
{
	return get_size(buff);
}

int CMementoTree::get_size_with_header()
{
	return get_size() + MEMENTOTREE_HEADER_SIZE;
}

int CMementoTree::get_treesize()
{
	int msize=0;
	CMEMENTOTREE_V::iterator i;
	for(i=mements.begin();i!=mements.end();i++)
	{
		msize += (*i)->get_treesize();
	}
	
	return get_size_with_header() + msize;
}


int CMementoTree::push_buffer(void *buffer,int size,int &offset)
{
	//obt@I[o[`FbN
	if(get_size()<offset+size)
	{return -1;}
	
	memcpy(&buff[offset+MEMENTOTREE_HEADER_SIZE],buffer,size);

	offset += size;

	return 0;
}

int CMementoTree::pop_buffer(void *buffer,int size,int &offset)
{
	//obt@I[o[`FbN
	if(get_size()<offset+size)
	{return -1;}

	memcpy(buffer,&buff[offset+MEMENTOTREE_HEADER_SIZE],size);

	offset += size;

	return 0;
}

int CMementoTree::push_mementotree(CMementoTree *mementotree)
{
	mements.push_back(mementotree);
	return 0;
}

CMementoTree *CMementoTree::get_mementotree(int index)
{
	return mements[index];
}

int CMementoTree::num_mementotree()
{
	return (int)mements.size();
}

int CMementoTree::get_serialized(void *buffer)
{
	int tsize,size;
	int offset=0;
	int i;

	tsize = get_treesize();		//g̃obt@TCY+qMementõTCY+8byte擾
	set_treesize(buff,tsize);	//R̈ɕۑ
	
	size = get_size_with_header();
	memcpy(buffer,buff,(size_t)size);
	offset += size;

	for(i=0;i<num_mementotree();i++)
	{
		mements[i]->get_serialized(&((char*)buffer)[offset]);
		offset += mements[i]->get_treesize();
	}

	return 0;
}
int CMementoTree::set_serialized(void *buffer)
{
	CMementoTree *m;
	int tsize,size;
	int offset=0;
	int i;

	size	= get_size(buffer)+MEMENTOTREE_HEADER_SIZE;
	tsize	= get_treesize(buffer);

	create_buffer(size);
	memcpy(buff,buffer,size);

	offset += size;
	while(offset<tsize)
	{
		m = new CMementoTree();
		m->set_serialized(&((char*)buffer)[offset]);
		offset += m->get_treesize();
		mements.push_back(m);
	}

	return 0;
}
